﻿namespace UltraToolbarsManagerAlignTools
{
    using System.Drawing;
    using Infragistics.Win;
    using Infragistics.Win.UltraWinToolbars;

    public class CF : IUIElementCreationFilter
    {
        private int editorWidth = 100;
        public void AfterCreateChildElements(UIElement parent)
        {
            //  Fix TextBoxTools
            var textBoxToolElement = parent as TextBoxToolUIElement;
            if(textBoxToolElement != null)
            {
                this.FixToolEditorWidthAndLocation(textBoxToolElement);
            }

            //  Fix ComboBoxTool
            var comboBoxToolElement = parent as ComboBoxToolUIElement;
            if(comboBoxToolElement != null)
            {
                this.FixToolEditorWidthAndLocation(comboBoxToolElement);
            }
        }

        public bool BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        private void FixToolEditorWidthAndLocation(UIElement parentElement)
        {
            //  Get ToolEditorAreaUIElement
            var toolEditorAreaElement = parentElement.GetDescendant(typeof(ToolEditorAreaUIElement));
            if(toolEditorAreaElement != null)
            {
                //  Fix the ToolEditorAreaUIElement's rectangle
                var oldRect = toolEditorAreaElement.Rect;
                toolEditorAreaElement.Rect = new Rectangle(
                    parentElement.Rect.Right - this.editorWidth,
                    oldRect.Top,
                    this.editorWidth,
                    oldRect.Height);
            }
        }
    }
}
